using System;
using Dll_CSharp_VSensor;
using System.Collections.Generic;
namespace testdll
{
    public class Program
    {
        static void Main(string[] args)
        {
            try
            {
                //获取相对路径
                string path = System.IO.Directory.GetCurrentDirectory();
                //实例化设备
                VSensorDLL VSensor = new VSensorDLL();
                //当前SDK版本
                string version = "";
                VSensor.GetSdkVersionString(ref version);
                Console.WriteLine("sdk version: {0}\n", version);
                //获取设备列表
                List<VSensorCameraInfoCLR> list = new List<VSensorCameraInfoCLR>(20);
                for (int i = 0; i < 20; i++)
                {
                    list.Add(new VSensorCameraInfoCLR());
                }
                int num = 0;
                VSensor.GetDeviceList(ref list, ref num);
                for (int i = 0; i < num; i++)
                {
                    Console.WriteLine("device num {0} : list[{1}] = {2}\n", i, i, list[i].CameraName);
                }
                //连接第一台设备
                int status = VSensor.DeviceConnect(0);
                if (status != 0)
                {
                    Console.WriteLine("connect device failed, status = {0}\n", status);
                    Console.ReadLine();
                }
                //设备参数初始化，仅上电时需要进行此操作，初始化需要等待15s
                Console.WriteLine("waiting for parameter init...\n");
                status = VSensor.DeviceParameterInit();
                if (status != 0)
                {
                    Console.WriteLine("parameter init failed, status = {0}\n", status);
                    Console.ReadLine();
                }
                //设置为采集模式
                status = VSensor.SetCaptureMode(1);
                if (status != 0)
                {
                    Console.WriteLine("set capture mode failed, status = {0}\n", status);
                    Console.ReadLine();
                }
                //单次采集测试
                Console.WriteLine("single restruction ...\n");
                status = VSensor.SingleRestruction(0);
                if (status != 0)
                {
                    Console.WriteLine("single restruction failed, status = {0}\n", status);
                    Console.ReadLine();
                }
                //获取当前相机输出分辨率
                int widthGray = 0;
                int heightGray = 0;
                int widthRgb = 0;
                int heightRgb = 0;
                VSensor.GetImageResolution(ref widthGray, ref heightGray, ref widthRgb, ref heightRgb);
                VSensorResultCLR result1 = new VSensorResultCLR(widthGray, heightGray, widthRgb, heightRgb);
                VSensor.GetRestructionResult(0, 0, 1, ref result1);
                //保存点云为ply格式
                status = VSensor.Save3DCloud(path + @"\test1.ply", result1, 0);
                if (status != 0)
                {
                    Console.WriteLine("save 3D points failed, status = {0}\n", status);
                    Console.ReadLine();
                }
                //切换为线模式(初始化默认为面模式)
                status = VSensor.SetRestructionMode(1);
                if (status != 0)
                {
                    Console.WriteLine("set restruction mode failed, status = {0}\n", status);
                    Console.ReadLine();
                }
                //设备参数初始化，切换线面重建模式都要初始化等待具体等待时间看设备型号
                Console.WriteLine("waiting for parameter init...\n");
                status = VSensor.DeviceParameterInit();
                if (status != 0)
                {
                    Console.WriteLine("parameter init failed, status = {0}\n", status);
                    Console.ReadLine();
                }
                //设置投影等级
                status = VSensor.SetProjectLight(1);
                if (status != 0)
                {
                    Console.WriteLine("set project light failed, status = {0}\n", status);
                    Console.ReadLine();
                }
                //设置为采集模式
                status = VSensor.SetCaptureMode(1);
                if (status != 0)
                {
                    Console.WriteLine("set capture mode failed, status = {0}\n", status);
                    Console.ReadLine();
                }
                //单次采集测试
                Console.WriteLine("single restruction ...\n");
                status = VSensor.SingleRestruction(0);
                if (status != 0)
                {
                    Console.WriteLine("single restruction failed, status = {0}\n", status);
                    Console.ReadLine();
                }
                //获取当前相机输出分辨率
                VSensorResultCLR result2 = new VSensorResultCLR(widthGray, heightGray);
                VSensor.GetRestructionResult(0, 0, 1, ref result2);
                //保存点云为ply格式
                status = VSensor.Save3DCloud(path + @"\test2.ply", result2, 0);
                if (status != 0)
                {
                    Console.WriteLine("save 3D points failed, status = {0}\n", status);
                    Console.ReadLine();
                }
                //反初始化设备
                status = VSensor.DeviceUnInit();
                if (status != 0)
                {
                    Console.WriteLine("device release failed, status = {0}\n", status);
                    Console.ReadLine();
                }
            }
            catch (Exception ex)
            {
                Console.WriteLine($"ex:{ex}");
            }
            Console.WriteLine("run success");
            Console.ReadLine();
            Console.ReadKey();
        }
    }
}
